local GetBuildInfo, InterfaceOptionsFrame_OpenToCategory, LibStub, SlashCmdList, idTweaks, idTweaksUtils, AceAddon, AceDB, AceDBOptions, AceConfig, AceConfigDialog, LibSharedMedia, Addon
do
  local _obj_0 = _G
  GetBuildInfo, InterfaceOptionsFrame_OpenToCategory, LibStub, SlashCmdList, idTweaks, idTweaksUtils = _obj_0.GetBuildInfo, _obj_0.InterfaceOptionsFrame_OpenToCategory, _obj_0.LibStub, _obj_0.SlashCmdList, _obj_0.idTweaks, _obj_0.idTweaksUtils
end
AceAddon = LibStub('AceAddon-3.0')
AceDB = LibStub('AceDB-3.0')
AceDBOptions = LibStub('AceDBOptions-3.0')
AceConfig = LibStub('AceConfig-3.0')
AceConfigDialog = LibStub('AceConfigDialog-3.0')
LibSharedMedia = LibStub('LibSharedMedia-3.0')
do
  local _class_0
  local _base_0 = {
    anchor = {
      TL = 'TOPLEFT',
      TC = 'TOP',
      TR = 'TOPRIGHT',
      ML = 'LEFT',
      MC = 'CENTER',
      MR = 'RIGHT',
      BL = 'BOTTOMLEFT',
      BC = 'BOTTOM',
      BR = 'BOTTOMRIGHT'
    },
    is_bc = function(self)
      return not self:is_retail()
    end,
    is_retail = function(self)
      return (select(4, GetBuildInfo())) > 30000
    end,
    add_module = function(self, module)
      self.modules[module.name] = module
    end,
    remove_module = function(self, module)
      return table.remove(self.modules, module.name)
    end,
    is_module_enabled = function(self, module_name)
      return not not self.modules[module_name] and self.modules[module_name].is_enabled()
    end,
    set_initializers = function(self)
      self.ace_addon.OnInitialize = function()
        self:register_media()
        self:register_options()
        return self:register_slash_commands()
      end
      self.ace_addon.OnEnable = function() end
      self.ace_addon.OnDisable = function() end
    end,
    set_database = function(self)
      self.db = AceDB:New(tostring(self.name) .. "DB", nil, 'Default')
    end,
    set_options = function(self)
      self.options = {
        name = 'idTweaks',
        type = 'group',
        args = { }
      }
      self.profile_options = AceDBOptions:GetOptionsTable(self.db)
    end,
    register_options = function(self)
      AceConfig:RegisterOptionsTable(self.name, self.options)
      AceConfigDialog:AddToBlizOptions(self.name)
      AceConfig:RegisterOptionsTable(tostring(self.name) .. "-Profiles", self.profile_options)
      return AceConfigDialog:AddToBlizOptions(tostring(self.name) .. "-Profiles", 'Profiles', self.name)
    end,
    register_slash_commands = function(self)
      _G.SLASH_IDTWEAKS1 = '/idt'
      _G.SLASH_IDTWEAKS2 = '/idtweaks'
      SlashCmdList['IDTWEAKS'] = function(msg)
        InterfaceOptionsFrame_OpenToCategory(self.name)
        InterfaceOptionsFrame_OpenToCategory(self.name)
        return InterfaceOptionsFrame_OpenToCategory('Automation')
      end
    end,
    register_media = function(self)
      LibSharedMedia:Register(LibSharedMedia.MediaType.FONT, 'Myriad Condensed Web', 'Interface\\AddOns\\idTweaks\\media\\fonts\\Myriad Condensed Web.ttf')
      LibSharedMedia:Register(LibSharedMedia.MediaType.BORDER, 'Square Clean', 'Interface\\AddOns\\idTweaks\\media\\textures\\ABFBorder')
      LibSharedMedia:Register(LibSharedMedia.MediaType.BACKGROUND, 'Chat Frame', 'Interface\\ChatFrame\\ChatFrameBackground')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'BantoBar', 'Interface\\AddOns\\idTweaks\\media\\textures\\banto')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'Smooth', 'Interface\\AddOns\\idTweaks\\media\\textures\\smooth')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'Perl', 'Interface\\AddOns\\idTweaks\\media\\textures\\perl')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'Glaze', 'Interface\\AddOns\\idTweaks\\media\\textures\\glaze')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'Charcoal', 'Interface\\AddOns\\idTweaks\\media\\textures\\Charcoal')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'Otravi', 'Interface\\AddOns\\idTweaks\\media\\textures\\otravi')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'Striped', 'Interface\\AddOns\\idTweaks\\media\\textures\\striped')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'LiteStep', 'Interface\\AddOns\\idTweaks\\media\\textures\\LiteStep')
      LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'Aluminium', 'Interface\\AddOns\\idTweaks\\media\\textures\\Aluminium')
      return LibSharedMedia:Register(LibSharedMedia.MediaType.STATUSBAR, 'Minimalist', 'Interface\\AddOns\\idTweaks\\media\\textures\\Minimalist')
    end,
    positioning = function(self)
      for k, v in pairs(idTweaks.modules) do
        v:positioning()
      end
    end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self)
      self.name = 'idTweaks'
      self.ace_addon = AceAddon:NewAddon(self.name, 'AceConsole-3.0')
      self.modules = { }
      self:set_initializers()
      self:set_database()
      return self:set_options()
    end,
    __base = _base_0,
    __name = "Addon"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  Addon = _class_0
end
_G.idTweaksAddon = Addon
