local *

{
  :idTweaks
  :idTweaksModule
  :idTweaksOptions
} = _G
{
  :SelectOption
  :RangeOption
} = idTweaksOptions

class Tooltips extends idTweaksModule
  new: (addon) =>
    -- print 'Tooltip#new'

    super addon, 'Tooltips', 'AceConsole-3.0', 'AceHook-3.0'

  set_options: =>
    -- print 'Tooltip#set_options'

    super!

    @options\add_option SelectOption @, 'anchor', 'Anchor Key', 'Where to anchor the tooltip to', {
      values:
        ANCHOR_CURSOR: 'Cursor Center'
        ANCHOR_CURSOR_LEFT: 'Cursor Left'
        ANCHOR_CURSOR_RIGHT: 'Cursor Right'
        ANCHOR_TOPLEFT: 'Top Left'
        ANCHOR_TOPRIGHT: 'Top Right'
        ANCHOR_BOTTOMLEFT: 'Bottom Left'
        ANCHOR_BOTTOMRIGHT: 'Bottom Right'
    }, {}, 'ANCHOR_CURSOR'

    @options\add_option RangeOption @, 'offset_x', 'Offset X', 'X axis offset', {
      min: -50
      max: 50
      step: 1
      bigStep: 1
    }, {}, 10

    @options\add_option RangeOption @, 'offset_y', 'Offset Y', 'Y axis offset', {
      min: -50
      max: 50
      step: 1
      bigStep: 1
    }, {}, 10

  enable: =>
    -- print 'Tooltip#enable'

    @ace_module\SecureHook 'GameTooltip_SetDefaultAnchor', (...) -> @handle_set_default_anchor ...

  disable: =>
    -- print 'Tooltip#disable'

    @ace_module\Unhook 'GameTooltip_SetDefaultAnchor'

  handle_set_default_anchor: (tooltip, self_object) =>
    -- print 'Tooltip#handle_set_default_anchor'

    tooltip\SetOwner self_object,
      @db.profile.anchor,
      @db.profile.offset_x,
      @db.profile.offset_y

idTweaks\add_module Tooltips idTweaks
